package model.fish;

import model.ILambda;
import model.fish.display.ImageFishDisplay;
import sysModel.fish.Fish;
import sysModel.fish.IFishBehavior;

import java.awt.*;

/**
 * A simple fish that throws an exception.
 *
 * @author Mathias Ricken
 */
public class ExceptionFish extends Fish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public ExceptionFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0), new IFishBehavior() {
            /**
             * Carry out movement behavior for the host fish.
             *
             * @param host fish to move.
             */
            public void move(final Fish host) {
                // attempt to move forward
                host.tryMoveFwd(new ILambda() {
                    public Object apply(Object param) {
                        // cannot move
                        // throw exception
                        throw new RuntimeException("booh!");
                    }
                }, new ILambda() {
                    public Object apply(Object param) {
                        // can move forward, do it
                        ((ILambda)param).apply(null);
                        return null;
                    }
                });
            }
        });
    }
}
