package model.fish.bad;

import model.fish.display.ImageFishDisplay;
import sysModel.fish.Fish;
import sysModel.fish.IFishBehavior;

import java.awt.*;

/**
 * A fish that locks up the system and prevents progress.
 *
 * @author Mathias Ricken
 */
public class LockupFish extends Fish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public LockupFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0), new IFishBehavior() {
            /**
             * Carry out movement behavior for the host fish.
             *
             * @param host fish to move.
             */
            public void move(Fish host) {
                while(true) {
                }
            }
        });
    }
}
