package model.fish.bad;

import model.ILambda;
import model.fish.display.ImageFishDisplay;
import sysModel.fish.Fish;
import sysModel.fish.IFishBehavior;

import java.awt.*;

/**
 * A fish that calls System.exit().
 *
 * @author Mathias Ricken
 */
public class SecurityFish extends Fish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public SecurityFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0), new IFishBehavior() {
            /**
             * Carry out movement behavior for the host fish.
             *
             * @param host fish to move.
             */
            public void move(Fish host) {
                host.tryMoveFwd(new ILambda() {
                    public Object apply(Object param) {
                        // change security manager
                        SecurityManager sm = new SecurityManager();
                        System.setSecurityManager(sm);
                        return null;
                    }
                }, new ILambda() {
                    public Object apply(Object param) {
                        // move forward
                        ((ILambda)param).apply(null);
                        return null;
                    }
                });
            }
        });
    }
}
